demo/cmp/urls.py
from django.urls import path

from cmp import views

app_name = "cmp"

urlpatterns =[
    path('list_provider/', views.ListProvider.as_view(), name="list_provider"),
    path('new_provider/', views.NewProvider.as_view(), name="new_provider"),
]

demo/demo/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include("home.urls", namespace="home")),
    path('inv/', include("inv.urls", namespace="inv")),
    path('cmp/', include("cmp.urls", namespace="cmp")),
]

demo/inv/urls.py
from django.urls import path

from inv import views

app_name = "inv"

urlpatterns = [
    path('list_category/', views.ListCategory.as_view(), name="list_category"),
    path('new_category/', views.NewCategory.as_view(), name="new_category"),
    path('update_category/<int:pk>/', views.UpdateCategory.as_view(), name="update_category"),
    path('delete_category/<int:pk>/', views.DeleteCategory.as_view(), name="delete_category"),
    path('new_subcategory/', views.NewSubCategory.as_view(), name="new_subcategory"),
    path('list_subcategory/', views.ListSubCategory.as_view(), name="list_subcategory"),
    path('update_subcategory/<int:pk>/', views.UpdateSubCategory.as_view(), name="update_subcategory"),
    path('delete_subcategory/<int:pk>/', views.DeleteSubCategory.as_view(), name="delete_subcategory"),
    path('detail_category/<int:pk>/', views.DetailCategory.as_view(), name="detail_category"),
    path('detail_subcategory/<int:pk>/', views.DetailSubCategory.as_view(), name="detail_subcategory"),
    path('ws/list_category/', views.wsList, name="ws_list_category"),
    path('list_brand/', views.ListBrand.as_view(), name="list_brand"),
    path('new_brand/', views.NewBrand.as_view(), name="new_brand"),
    path('update_brand/<int:pk>/', views.UpdateBrand.as_view(), name="update_brand"),
    path('delete_brand/<int:pk>/', views.DeleteBrand.as_view(), name="delete_brand"),
    path('list_measure/', views.ListMeasure.as_view(), name="list_measure"),
    path('new_measure/', views.NewMeasure.as_view(), name="new_measure"),
    path('update_measure/<int:pk>/', views.UpdateMeasure.as_view(), name="update_measure"),
    path('delete_measure/<int:pk>/', views.DeleteMeasure.as_view(), name="delete_measure"),
    path('list_product/', views.ListProduct.as_view(), name="list_product"),
    path('new_product/', views.NewProduct.as_view(), name="new_product"),
    path('update_product/<int:pk>/', views.UpdateProduct.as_view(), name="update_product"),
]

demo/inv/models.py
from django.db import models

from django.contrib.auth.models import User



# Create your models here.

class BrandQuerySet(models.QuerySet):
    def old(self):
        return self.filter(id__lt=3)


class BaseModel(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    status = models.BooleanField(default=True)
    timestamp = models.DateTimeField(auto_now_add=True)
    update = models.DateTimeField(auto_now=True)
    user_update = models.IntegerField(blank=True, null=True)


    class Meta:
        abstract = True


class Category(BaseModel):
    description = models.CharField(
        max_length = 128,
        help_text = "Category Description",
        unique = True
    )

    def __str__(self):
        return "{}".format(self.description)

    def save(self):
        self.description = self.description.upper()
        super(Category, self).save()

    class Meta:
        verbose_name_plural = "Categories"



class SubCategory(BaseModel):
    category = models.ForeignKey(Category, on_delete=models.CASCADE)
    description = models.CharField(
        max_length = 128,
        help_text = "SubCategory Description"
    )

    def __str__(self):
        return "{0} - {1}".format(self.category.description, self.description)


    def save(self):
        self.description = self.description.upper()
        super(SubCategory, self).save()

    class Meta:
        verbose_name_plural = "SubCategories"
        unique_together = ("category", "description")


class Brand(BaseModel):
    objects = BrandQuerySet.as_manager()
    description = models.CharField(
        max_length = 128,
        help_text = "Description Brand",
        unique = True
    )

    def __str__(self):
        return "{}".format(self.description)

    def save(self):
        self.description = self.description.upper()
        super(Brand, self).save()

    class Meta:
        verbose_name_plural = "Brands"



class Measure(BaseModel):
    description = models.CharField(
        max_length = 128,
        help_text = "Measure Description",
        unique = True
    )

    def __str__(self):
        return "{}".format(self.description)

    def save(self):
        self.description = self.description.upper()
        super(Measure, self).save()

    class Meta:
        verbose_name_plural = "Measure"


##### PRODUCT MODEL #####

class Product(BaseModel):
    code = models.CharField(max_length=16, unique=True)
    bar_code = models.CharField(max_length=16)
    description = models.CharField(max_length=128)
    price = models.FloatField(default=0)
    stock = models.IntegerField(default=0)
    last_buy = models.DateField(null=True, blank=True)
    brand = models.ForeignKey(Brand, on_delete=models.CASCADE)
    measure = models.ForeignKey(Measure, on_delete=models.CASCADE)
    subcategory = models.ForeignKey(SubCategory, on_delete=models.CASCADE)


    def __str__(self):
        return "{}".format(self.description)


    def save(self):
        self.description = self.description.upper()
        super(Product, self).save()


    class Meta:
        verbose_name_plural = "Products"
        unique_together = ("code", "bar_code")

demo/inv/forms.py
from django import forms

from .models import Category, SubCategory, Brand, Measure, Product

class NewCategoryForm(forms.ModelForm):
    class Meta:
        model = Category
        fields = [
            "description",
            "status",
        ]
        labels = {
            "description": "Category",
            "status": "Status"
        }
        widget = {
            "description": forms.TextInput
        }

    def __init__(self, *args, **kwargs):
            super().__init__(*args, **kwargs)
            for field in iter(self.fields):
                self.fields[field].widget.attrs.update({
                    "class": "form-control"
                })





class NewSubCategoryForm(forms.ModelForm):
    class Meta:
        model = SubCategory
        fields = [
            "category",
            "description",
            "status",
        ]
        labels = {
            "description": "Category",
            "status": "Status"
        }
        widget = {
            "description": forms.TextInput
        }

    def __init__(self, *args, **kwargs):
            super().__init__(*args, **kwargs)
            for field in iter(self.fields):
                self.fields[field].widget.attrs.update({
                    "class": "form-control"
                })
            self.fields["category"].empty_label = "Choose Category"



class BrandForm(forms.ModelForm):
    class Meta:
        model = Brand
        fields = [
            "description",
            "status",
        ]
        labels = {
            "description": "Brand",
            "status": "Status"
        }
        widget = {
            "description": forms.TextInput
        }

    def __init__(self, *args, **kwargs):
            super().__init__(*args, **kwargs)
            for field in iter(self.fields):
                self.fields[field].widget.attrs.update({
                    "class": "form-control"
                })


class MeasureForm(forms.ModelForm):
    class Meta:
        model = Measure
        fields = [
            "description",
            "status",
        ]
        labels = {
            "description": "Measure",
            "status": "Status"
        }
        widget = {
            "description": forms.TextInput
        }

    def __init__(self, *args, **kwargs):
            super().__init__(*args, **kwargs)
            for field in iter(self.fields):
                self.fields[field].widget.attrs.update({
                    "class": "form-control"
                })




class ProductForm(forms.ModelForm):
    class Meta:
        model = Product
        fields = [ ## "__all__"
            "code",
            "bar_code",
            "description",
            "status",
            "price",
            "stock",
            "last_buy",
            "brand",
            "subcategory",
            "measure"
        ]
        exclude = ["user", "user_update", "timestamp", "update"]
        labels = {
            "code": "Code",
            "bar_code": "Bar Code",
            "description": "Product Description",
            "status": "Status",
            "price": "Price",
            "stock": "Stock",
            "last_buy": "Last Buy",
            "brand": "Brand",
            "subcategory": "SubCategory",
            "measure": "Measure",
        }
        widget = {
            "description": forms.TextInput
        }

    def __init__(self, *args, **kwargs):
            super().__init__(*args, **kwargs)
            for field in iter(self.fields):
                self.fields[field].widget.attrs.update({
                    "class": "form-control"
                })

demo/inv/views.py
from django.shortcuts import render
from django.urls import reverse_lazy

from django.views import generic
from django.contrib.auth.mixins import LoginRequiredMixin

from django.http import JsonResponse, HttpResponse
from django.core import serializers

from .models import Category, SubCategory, Brand, Measure, Product
from .forms import NewCategoryForm, NewSubCategoryForm, BrandForm, MeasureForm, ProductForm
# Create your views here.

##### CRUD Category #####


##### RETRIEVE (List, Detail) #####
## generic.ListView
class ListCategory(LoginRequiredMixin, generic.ListView):
    template_name = "inv/list_category.html"
    model = Category
    context_object_name = "obj"
    login_url = "home:login"

## generic.DetailView
class DetailCategory(LoginRequiredMixin, generic.DetailView):
    template_name = "inv/detail_category.html"
    model = Category
    login_url = "home:login"
    context_object_name = "obj"



##### CREATE #####
## generic.CreateView
class NewCategory(LoginRequiredMixin, generic.CreateView):
    template_name = "inv/new_category.html"
    model = Category
    context_object_name = "obj"
    form_class = NewCategoryForm
    login_url = "home:login"
    success_url = reverse_lazy("inv:list_category")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)

##### UPDATE #####
## generic.UpdateView
class UpdateCategory(LoginRequiredMixin, generic.UpdateView):
    template_name = "inv/update_category.html"
    model = Category
    context_object_name = "obj"
    form_class = NewCategoryForm
    login_url = "home:login"
    success_url = reverse_lazy("inv:list_category")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)



##### DELETE #####
## generic.DeleteView
class DeleteCategory(LoginRequiredMixin, generic.DeleteView):
    template_name = "inv/delete_category.html"
    model = Category
    context_object_name = "obj"
    login_url = "home:login"
    success_url = reverse_lazy("inv:list_category")




##### CRUD SUBCATEGORY #####

##### RETRIEVE #####
## generic.ListView
class ListSubCategory(LoginRequiredMixin, generic.ListView):
    template_name = "inv/list_subcategory.html"
    model = SubCategory
    context_object_name = "obj"
    login_url = "home:login"


class DetailSubCategory(LoginRequiredMixin, generic.DetailView):
    template_name = "inv/detail_subcategory.html"
    model = SubCategory
    login_url = "home:login"
    context_object_name = "obj"


##### CREATE #####
## generic.CreateView
class NewSubCategory(LoginRequiredMixin, generic.CreateView):
    template_name = "inv/new_subcategory.html"
    model = SubCategory
    context_object_name = "obj"
    form_class = NewSubCategoryForm
    login_url = "home:login"
    success_url = reverse_lazy("inv:list_subcategory")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)


##### UPDATE #####
## generic.UpdateView
class UpdateSubCategory(LoginRequiredMixin, generic.UpdateView):
    template_name = "inv/update_subcategory.html"
    model = SubCategory
    context_object_name = "obj"
    form_class = NewSubCategoryForm
    login_url = "home:login"
    success_url = reverse_lazy("inv:list_subcategory")


    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)

##### DELETE #####
## generic.DeleteView
class DeleteSubCategory(LoginRequiredMixin, generic.DeleteView):
    template_name = "inv/delete_subcategory.html"
    model = SubCategory
    context_object_name = "obj"
    success_url = reverse_lazy("inv:list_subcategory")
    login_url = "home:login"


##### API's #####
## ws JSON

def wsList(request):
    data = serializers.serialize('json', Category.objects.filter(status=False))
    return HttpResponse(data, content_type="application/json")


##### CRUD BRAND #####

class ListBrand(LoginRequiredMixin, generic.ListView):
    template_name = "inv/brand_category.html"
    model = Brand
    context_object_name = "obj"
    login_url = "home:login"


class NewBrand(LoginRequiredMixin, generic.CreateView):
    template_name = "inv/new_brand.html"
    model = Brand
    form_class = BrandForm
    login_url = "home:login"
    context_object_name = "obj"
    success_url = reverse_lazy("inv:list_brand")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)


class UpdateBrand(LoginRequiredMixin, generic.UpdateView):
    template_name = "inv/update_brand.html"
    model = Brand
    form_class = BrandForm
    login_url = "home:login"
    context_object_name = "obj"
    success_url = reverse_lazy("inv:list_brand")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)


class DeleteBrand(LoginRequiredMixin, generic.DeleteView):
    template_name = "inv/delete_brand.html"
    model = Brand
    context_object_name = "obj"
    success_url = reverse_lazy("inv:list_brand")
    login_url = "home:login"



##### CRUD Measure #####


##### RETRIEVE (List, Detail) #####
## generic.ListView
class ListMeasure(LoginRequiredMixin, generic.ListView):
    template_name = "inv/list_measure.html"
    model = Measure
    context_object_name = "obj"
    login_url = "home:login"

## generic.DetailView
# class DetailCategory(LoginRequiredMixin, generic.DetailView):
#     template_name = "inv/detail_category.html"
#     model = Category
#     login_url = "home:login"
#     context_object_name = "obj"



##### CREATE #####
## generic.CreateView
class NewMeasure(LoginRequiredMixin, generic.CreateView):
    template_name = "inv/new_measure.html"
    model = Measure
    context_object_name = "obj"
    form_class = MeasureForm
    login_url = "home:login"
    success_url = reverse_lazy("inv:list_measure")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)

##### UPDATE #####
## generic.UpdateView
class UpdateMeasure(LoginRequiredMixin, generic.UpdateView):
    template_name = "inv/update_measure.html"
    model = Measure
    context_object_name = "obj"
    form_class = MeasureForm
    login_url = "home:login"
    success_url = reverse_lazy("inv:list_measure")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)



##### DELETE #####
## generic.DeleteView
class DeleteMeasure(LoginRequiredMixin, generic.DeleteView):
    template_name = "inv/delete_measure.html"
    model = Measure
    context_object_name = "obj"
    login_url = "home:login"
    success_url = reverse_lazy("inv:list_measure")


##### CRUD PRODUCT #####


##### RETRIEVE (List, Detail) #####
## generic.ListView
class ListProduct(LoginRequiredMixin, generic.ListView):
    template_name = "inv/list_product.html"
    model = Product
    context_object_name = "obj"
    login_url = "home:login"

## generic.DetailView
# class DetailCategory(LoginRequiredMixin, generic.DetailView):
#     template_name = "inv/detail_category.html"
#     model = Category
#     login_url = "home:login"
#     context_object_name = "obj"



##### CREATE #####
## generic.CreateView
class NewProduct(LoginRequiredMixin, generic.CreateView):
    template_name = "inv/new_product2.html"
    model = Product
    context_object_name = "obj"
    form_class = ProductForm
    login_url = "home:login"
    success_url = reverse_lazy("inv:list_product")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)

##### UPDATE #####
## generic.UpdateView
class UpdateProduct(LoginRequiredMixin, generic.UpdateView):
    template_name = "inv/new_product2.html"
    model = Product
    context_object_name = "obj"
    form_class = ProductForm
    login_url = "home:login"
    success_url = reverse_lazy("inv:list_product")

    def form_valid(self, form):
        form.instance.user = self.request.user
        return super().form_valid(form)



##### DELETE #####
## generic.DeleteView
# class DeleteMeasure(LoginRequiredMixin, generic.DeleteView):
#     template_name = "inv/delete_measure.html"
#     model = Measure
#     context_object_name = "obj"
#     login_url = "home:login"
#     success_url = reverse_lazy("inv:list_measure")

demo/templates/inv/delete_brand.html
{% extends "base.html" %}

{% block title %}DeleteBrand{% endblock title%}


{% block page_content %}
  ¿Realmente quieres eliminar al objeto <h3>{{ obj }}</h3>?
  <form action="" method="post">
    {% csrf_token %}
    <button type="submit" name="button" class="btn btn-circle btn-lg btn-danger">Yes</button>
    <a href="{% url 'inv:list_brand' %}" class="btn btn-circle btn-lg btn-warning">No</a>
  </form>

{% endblock page_content %}

demo/templates/inv/delete_measure.html
{% extends "base.html" %}

{% block title %}DeleteMeasure{% endblock title%}


{% block page_content %}
  ¿Realmente quieres eliminar al objeto <h3>{{ obj }}</h3>?
  <form action="" method="post">
    {% csrf_token %}
    <button type="submit" name="button" class="btn btn-circle btn-lg btn-danger">Yes</button>
    <a href="{% url 'inv:list_measure' %}" class="btn btn-circle btn-lg btn-warning">No</a>
  </form>

{% endblock page_content %}

demo/templates/inv/detail_category.html
{% extends 'base.html' %}
{% block title %}Detail Category{% endblock title %}

{% block page_content %}
  {{ obj }}
  {{ obj.user }}
  {{ obj.timestamp }}
{% endblock page_content %}

demo/templates/inv/detail_subcategory.html
{% extends 'base.html' %}
{% block title %}Detail SubCategory{% endblock title %}

{% block page_content %}
  {{ obj }}
  {{ obj.user }}
  {{ obj.timestamp }}
{% endblock page_content %}

demo/templates/inv/list_category.html
{% extends "base.html" %}

{% block title %}Categories List{% endblock title %}

{% block page_content %}


<!-- Dropdown Card Example -->
<div class="card shadow mb-4">
  <!-- Card Header - Dropdown -->
  <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
    <h6 class="m-0 font-weight-bold text-primary">Categories</h6>
    <div class="dropdown no-arrow">
      <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
        <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
      </a>
      <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
        <div class="dropdown-header">Actions:</div>
        <a class="dropdown-item" href="{% url 'inv:new_category' %}"><i class="far fa-calendar-plus"></i>NewCategory</a>
        <a class="dropdown-item" href="">NewSubCategory</a>
        <div class="dropdown-divider"></div>
        <a class="dropdown-item" href="#">Something else here</a>
      </div>
    </div>
  </div>
  <!-- Card Body -->
  <div class="card-body">
    {% if not obj %}
      <h3> Not Categories Yet!! </h3>
    {% else %}
      <table class="table table-striped table-hover">
        <thead>
          <th> Id </th>
          <th> Description </th>
          <th> Status </th>
          <th> TimeStamp </th>
          <th> Update </th>
          <th class="all"> Actions </th>
        </thead>
        <tbody>
          {% for item in obj %}
             <tr>
               <th>{{ item.id }}</th>
               <th>{{ item.description }}</th>
               <th>{{ item.status|yesno:"Active, Inactive" }}</th>
               <th>{{ item.timestamp|date:"d/m/Y H:i:s" }}</th>
               <th>{{ item.update|date:"d/m/Y H:i:s" }}</th>
               <th>
                 <a href="{% url 'inv:update_category' item.pk %}" class="btn btn-warning btn-circle" role="button"><i class="far fa-edit"></i></a>
                 <a href="{% url 'inv:delete_category' item.pk %}" class="btn btn-danger btn-circle" role="button"><i class="far fa-trash-alt"></i></a>
               </th>
             </tr>
          {% endfor %}
        </tbody>
      </table>
    {% endif %}
  </div>
</div>



{% endblock page_content %}

{% block js_scripts %}
  <script type="text/javascript">
    // Call the DataTable JQuery plugin//
    $(document).ready(function(){
      $('.table').DataTable();
    });
  </script>>
{% endblock js_scripts %}

demo/templates/inv/list_product.html
{% extends "base.html" %}

{% block title %}Products List{% endblock title %}

{% block page_content %}


<!-- Dropdown Card Example -->
<div class="card shadow mb-4">
  <!-- Card Header - Dropdown -->
  <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
    <h6 class="m-0 font-weight-bold text-primary">Product</h6>
    <div class="dropdown no-arrow">
      <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
        <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
      </a>
      <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
        <div class="dropdown-header">Actions:</div>
        <a class="dropdown-item" onclick="return open_modal('{% url 'inv:new_product' %}')" href="#"><i class="far fa-calendar-plus"></i>NewProduct</a>
        <a class="dropdown-item" href="#">Another action</a>
        <div class="dropdown-divider"></div>
        <a class="dropdown-item" href="#">Something else here</a>
      </div>
    </div>
  </div>
  <!-- Card Body -->
  <div class="card-body">
    {% if not obj %}
      <h3> Not Product Yet!! </h3>
    {% else %}
      <table class="table table-striped table-hover">
        <thead>
          <th> Code </th>
          <th> Bar Code </th>
          <th> Description </th>
          <th> Status </th>
          <th> Stock </th>
          <th> Brand </th>
          <th> Measure </th>
          <th class="all"> Actions </th>
        </thead>
        <tbody>
          {% for item in obj %}
             <tr>
               <td> {{ item.code }} </td>
               <td> {{ item.bar_code }} </td>
               <td>{{ item.description }}</td>
               <td>{{ item.status|yesno:"Active, Inactive" }}</td>
               <td>{{ item.stock }}</td>
               <td> {{ item.brand }} </td>
               <td> {{ item.measure }} </td>
               <th>
                 <button type="button" onclick="return open_modal('{% url 'inv:update_product' item.pk %}')" class="btn btn-warning btn-circle" name="button">
                   <i class="far fa-edit"></i>
                 </button>

               </th>
             </tr>
          {% endfor %}
        </tbody>
      </table>
    {% endif %}
  </div>
</div>



{% endblock page_content %}

{% block js_scripts %}
  <script type="text/javascript">
    // Call the DataTable JQuery plugin//
    $(document).ready(function(){
      $('.table').DataTable();
    });
  </script>>
{% endblock js_scripts %}

demo/templates/inv/new_brand.html
{% extends "base.html" %}

{% block title %} NewBrand {% endblock title %}


{% block page_content %}
  <form method="post" class="form-inline" action="">
    {% csrf_token %}
    {{ form }}
    <button type="submit" class="btn btn-success btn-circle btn-lg" name="button">Save</button>
    <a href="{% url 'inv:list_brand' %} " class="btn btn-circle btn-warning btn-lg">Back</a>
  </form>
{% endblock page_content %}

demo/templates/inv/new_category.html
{% extends "base.html" %}

{% block title %} NewCategory {% endblock title %}


{% block page_content %}
  <form method="post" class="form-inline" action="">
    {% csrf_token %}
    {{ form }}
    <button type="submit" class="btn btn-success btn-circle btn-lg" name="button">Save</button>
    <a href="{% url 'inv:list_category' %} " class="btn btn-circle btn-warning btn-lg">Back</a>
  </form>
{% endblock page_content %}

demo/templates/inv/new_product2.html
<div class="modal-dialog modal-lg">
  <div class="modal-content">
    {% if obj %}
      <form method="POST" role="form" class="form-inline" action="{% url 'inv:update_product' obj.pk %}">
    {% else %}
      <form method="POST" role="form" class="form-inline" action="{% url 'inv:new_product' %}">
    {% endif %}


      <div class="col-xl-12 col-md-12 mb-12">
        {% if obj %}
          <div class="card border-left-primary shadow h-100 py-2">
        {% else %}
          <div class="card border-left-success shadow h-100 py-2">
        {% endif %}
          <div class="card-body">
            <div class="row no-gutters align-items-center">
              <div class="col mr-2">
                <div class="text-xs font-weight-bold text-success text-uppercase mb-1">
                  {% if obj %} Edit {% else %} New {% endif %} Product
                </div>
                    <!-- {{ form }} -->
                    <div class="dropdown-divider"> </div>

                    <!-- ROW -->
                     <div class="row">

                           {% csrf_token  %}
                            {{ form.as_p }}
                    </div>
                    </div>

                  <!-- ENDROW -->




                  <div class="dropdown-divider"></div>

                    <div class="row">
                      <div class="col">
                        <button type="submit" name="button"  class="btn btn-success"><span class="fa fa-save"></span>Save</button>

                        <button type="button" name="button" class="btn btn-warning" onclick="return close_modal()">Cancel</button>
                      </div>
                    </div>



                </div>

              </div>
            </div>
          </div>
      </div>

      </form>

  </div>
</div>

demo/templates/inv/new_subcategory.html
{% extends "base.html" %}

{% block title %} SubNewCategory {% endblock title %}


{% block page_content %}
  <form method="post" class="form-inline" action="">
    {% csrf_token %}
    {{ form.as_p }}
    <button type="submit" class="btn btn-success btn-circle btn-lg" name="button">Save</button>
    <a href="{% url 'inv:list_subcategory' %} " class="btn btn-circle btn-warning btn-lg">Back</a>
  </form>
{% endblock page_content %}

demo/templates/inv/update_brand.html
{% extends "base.html" %}

{% block title %} UpdateBrand {% endblock title %}


{% block page_content %}
  <form method="post" class="form-inline" action="">
    {% csrf_token %}
    {{ form }}
    <button type="submit" class="btn btn-success btn-circle btn-lg" name="button">Save</button>
    <a href="{% url 'inv:list_brand' %} " class="btn btn-circle btn-warning btn-lg">Back</a>
  </form>
{% endblock page_content %}

demo/templates/inv/update_category.html
{% extends "base.html" %}

{% block title %} UpdateCategory {% endblock title %}


{% block page_content %}
  <form method="post" class="form-inline" action="">
    {% csrf_token %}
    {{ form }}
    <button type="submit" class="btn btn-success btn-circle btn-lg" name="button">Save</button>
    <a href="{% url 'inv:list_category' %} " class="btn btn-circle btn-warning btn-lg">Back</a>
  </form>
{% endblock page_content %}

demo/templates/inv/update_measure.html
{% extends "base.html" %}

{% block title %} UpdateMeasure {% endblock title %}


{% block page_content %}
  <form method="post" class="form-inline" action="">
    {% csrf_token %}
    {{ form }}
    <button type="submit" class="btn btn-success btn-circle btn-lg" name="button">Save</button>
    <a href="{% url 'inv:list_measure' %} " class="btn btn-circle btn-warning btn-lg">Back</a>
  </form>
{% endblock page_content %}

demo/templates/inv/update_subcategory.html
{% extends "base.html" %}

{% block title %} UpdateSubCategory {% endblock title %}


{% block page_content %}
  <form method="post" class="form-inline" action="">
    {% csrf_token %}
    {{ form }}
    <button type="submit" class="btn btn-success btn-circle btn-lg" name="button">Save</button>
    <a href="{% url 'inv:list_subcategory' %} " class="btn btn-circle btn-warning btn-lg">Back</a>
  </form>
{% endblock page_content %}